//
//  AccelerometerViewController.m
//  ToDo List
//
//  Created by nPrimary on 6/5/15.
//  Copyright (c) 2015 nPrimary. All rights reserved.
//

#import "AccelerometerViewController.h"

@interface AccelerometerViewController ()

@end

@implementation AccelerometerViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    
    appDel = [[UIApplication sharedApplication] delegate];
    // Do any additional setup after loading the view.
}

-(BOOL)shouldAutorotate{
    return NO;
}

- (NSUInteger)supportedInterfaceOrientations{
    return UIInterfaceOrientationMaskPortrait;
}

- (void)viewDidAppear:(BOOL)animated
{
    [super viewDidAppear:animated];
    [self startMyMotionDetect];
}

- (void)viewDidDisappear:(BOOL)animated
{
    [super viewDidDisappear:animated];
    [self.motionManager stopDeviceMotionUpdates];
}


- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

- (CMMotionManager *)motionManager
{
    CMMotionManager *motionManager = nil;
    id appDelegate = [UIApplication sharedApplication].delegate;
    if ([appDelegate respondsToSelector:@selector(motionManager)]) {
        motionManager = [appDelegate motionManager];
    }
    return motionManager;
}

- (void)startMyMotionDetect
{
    [self.motionManager setDeviceMotionUpdateInterval:0.01];
    [self.motionManager startDeviceMotionUpdatesUsingReferenceFrame:CMAttitudeReferenceFrameXMagneticNorthZVertical toQueue:[[NSOperationQueue alloc]init ] withHandler:^(CMDeviceMotion *motion, NSError *error) {
        dispatch_async(dispatch_get_main_queue(),
                       ^{
                           [[appDel oscManager] sendFloatArray:@"/accel" floatArray:@[[NSNumber numberWithFloat:motion.userAcceleration.x],[NSNumber numberWithFloat:motion.userAcceleration.y],[NSNumber numberWithFloat:motion.userAcceleration.z]]];
                       }
                       );
    }
     ];
}



/*
 #pragma mark - Navigation
 
 // In a storyboard-based application, you will often want to do a little preparation before navigation
 - (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender {
 // Get the new view controller using [segue destinationViewController].
 // Pass the selected object to the new view controller.
 }
 */

@end


