//
//  GyroViewController.m
//  ToDo List
//
//  Created by nPrimary on 6/7/15.
//  Copyright (c) 2015 nPrimary. All rights reserved.
//

#import "GyroViewController.h"

@interface GyroViewController ()

@end

@implementation GyroViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    appDel = [[UIApplication sharedApplication] delegate];
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
}

- (CMMotionManager *)motionManager
{
    CMMotionManager *motionManager = nil;
    id appDelegate = [UIApplication sharedApplication].delegate;
    if ([appDelegate respondsToSelector:@selector(motionManager)]) {
        motionManager = [appDelegate motionManager];
    }
    return motionManager;
}

- (void)viewDidAppear:(BOOL)animated
{
    [super viewDidAppear:animated];
    [self startMyGyroDetect];
}

- (void)viewDidDisappear:(BOOL)animated
{
    [super viewDidDisappear:animated];
    [self.motionManager stopDeviceMotionUpdates];
}

- (void)startMyGyroDetect
{
    [self.motionManager setDeviceMotionUpdateInterval:0.01];
    [self.motionManager startDeviceMotionUpdatesUsingReferenceFrame:CMAttitudeReferenceFrameXMagneticNorthZVertical toQueue:[[NSOperationQueue alloc]init ] withHandler:^(CMDeviceMotion *motion, NSError *error) {
        dispatch_async(dispatch_get_main_queue(),
                       ^{
                           [[appDel oscManager] sendFloatArray:@"/orientation" floatArray:@[[NSNumber numberWithFloat:motion.attitude.roll],[NSNumber numberWithFloat:motion.attitude.pitch],[NSNumber numberWithFloat:motion.attitude.yaw]]];
                       }
                       );
    }
     ];
}

/*
 #pragma mark - Navigation
 
 // In a storyboard-based application, you will often want to do a little preparation before navigation
 - (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender {
 // Get the new view controller using [segue destinationViewController].
 // Pass the selected object to the new view controller.
 }
 */

@end
