//
//  HomeViewController.m
//  ToDo List
//
//  Created by nPrimary on 6/6/15.
//  Copyright (c) 2015 nPrimary. All rights reserved.
//

#import "HomeViewController.h"
#include <ifaddrs.h>
#include <arpa/inet.h>

#define DEFAULTHOST @"169.231.96.160"

@interface HomeViewController ()
@property (weak, nonatomic) IBOutlet UITextField *ipAddress;
@property (weak, nonatomic) IBOutlet UITextField *thisIpAddress;

@end

@implementation HomeViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    
     appDel = [[UIApplication sharedApplication] delegate];
    
    _thisIpAddress.text =[self getIPAddress];
    [[appDel oscManager] setHost:DEFAULTHOST];
    _ipAddress.text = DEFAULTHOST;
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
}
- (IBAction)ipAddressEdited:(id)sender {
    [[appDel oscManager] setHost:_ipAddress.text];
     UITextField *theField = (UITextField*)sender;
     [theField resignFirstResponder];
}

- (NSString *)getIPAddress {
    
    NSString *address = @"error";
    struct ifaddrs *interfaces = NULL;
    struct ifaddrs *temp_addr = NULL;
    int success = 0;
    // retrieve the current interfaces - returns 0 on success
    success = getifaddrs(&interfaces);
    if (success == 0) {
        // Loop through linked list of interfaces
        temp_addr = interfaces;
        while(temp_addr != NULL) {
            if(temp_addr->ifa_addr->sa_family == AF_INET) {
                // Check if interface is en0 which is the wifi connection on the iPhone
                if([[NSString stringWithUTF8String:temp_addr->ifa_name] isEqualToString:@"en0"]) {
                    // Get NSString from C String
                    address = [NSString stringWithUTF8String:inet_ntoa(((struct sockaddr_in *)temp_addr->ifa_addr)->sin_addr)];
                    
                }
                
            }
            
            temp_addr = temp_addr->ifa_next;
        }
    }
    // Free memory
    freeifaddrs(interfaces);
    return address;
    
}

/*
#pragma mark - Navigation

// In a storyboard-based application, you will often want to do a little preparation before navigation
- (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender {
    // Get the new view controller using [segue destinationViewController].
    // Pass the selected object to the new view controller.
}
*/

@end
