//
//  MagViewController.m
//  ToDo List
//
//  Created by nPrimary on 6/7/15.
//  Copyright (c) 2015 nPrimary. All rights reserved.
//

#import "MagViewController.h"

@interface MagViewController ()

@end

@implementation MagViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    appDel = [[UIApplication sharedApplication] delegate];
    // Do any additional setup after loading the view.
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}


- (CMMotionManager *)motionManager
{
    CMMotionManager *motionManager = nil;
    
    id appDelegate = [UIApplication sharedApplication].delegate;
    
    if ([appDelegate respondsToSelector:@selector(motionManager)]) {
        motionManager = [appDelegate motionManager];
    }
    
    return motionManager;
}

- (void)viewDidAppear:(BOOL)animated
{
    [super viewDidAppear:animated];
    [self startMyMagDetect];
}

- (void)viewDidDisappear:(BOOL)animated
{
    [super viewDidDisappear:animated];
    [self.motionManager stopDeviceMotionUpdates];
}

- (void)startMyMagDetect
{
    
    [self.motionManager setDeviceMotionUpdateInterval:0.05];
    
    [self.motionManager startDeviceMotionUpdatesUsingReferenceFrame:CMAttitudeReferenceFrameXMagneticNorthZVertical toQueue:[[NSOperationQueue alloc]init ] withHandler:^(CMDeviceMotion *motion, NSError *error) {
        
        dispatch_async(dispatch_get_main_queue(),
                       ^{
                           
                           [[appDel oscManager] sendMagneticField:@"/mag" valX:motion.magneticField.field.x valY:motion.magneticField.field.y valZ:motion.magneticField.field.z];
                           
                       }
                       );
    }
     ];
}



/*
 #pragma mark - Navigation
 
 // In a storyboard-based application, you will often want to do a little preparation before navigation
 - (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender {
 // Get the new view controller using [segue destinationViewController].
 // Pass the selected object to the new view controller.
 }
 */

@end
