//
//  OSCManager.m
//  ToDo List
//
//  Created by nPrimary on 6/5/15.
//  Copyright (c) 2015 nPrimary. All rights reserved.
//

#import "OSCManager.h"
#import "SliderViewController.h"

#define SENDPORT 3000
#define RECEIVEPORT 3001

@interface OSCManager()
@property (strong, nonatomic) F53OSCClient* oscClient;
@property (strong, nonatomic) F53OSCServer* oscServer;
@property (weak, nonatomic)  NSString *host;
@property UIResponder *appDel;
@end

@implementation OSCManager

-(id)init{
    NSLog(@"initOSCManager");
    self.oscClient = [[F53OSCClient alloc] init];
    return self;
}

-(void)sendSlider:(NSString*)addrPattern sliderNum:(int)value val2:(float)value2{
    F53OSCMessage *message = [F53OSCMessage messageWithAddressPattern:addrPattern arguments:@[[NSNumber numberWithInt:value],[NSNumber numberWithFloat:value2]]];
    [self.oscClient sendPacket:message toHost:_host onPort:SENDPORT];
}

-(void)sendMagneticField:(NSString*)addrPattern valX:(float)value valY:(float)value2 valZ:(float)value3{
    F53OSCMessage *message = [F53OSCMessage messageWithAddressPattern:addrPattern arguments:@[[NSNumber numberWithFloat:value],[NSNumber numberWithFloat:value2],[NSNumber numberWithFloat:value3]]];
    [self.oscClient sendPacket:message toHost:_host onPort:SENDPORT];
}

-(void)sendFloatArray:(NSString*)addrPattern floatArray:(NSArray*)array{
    F53OSCMessage *message = [F53OSCMessage messageWithAddressPattern:addrPattern arguments:array];
    [self.oscClient sendPacket:message toHost:_host onPort:SENDPORT];
}

-(void)sendFloat:(NSString*)addrPattern theValue:(float)value{
    NSLog(addrPattern);
    F53OSCMessage *message = [F53OSCMessage messageWithAddressPattern:addrPattern arguments:@[[NSNumber numberWithFloat:value]]];
    [self.oscClient sendPacket:message toHost:_host onPort:SENDPORT];
}

-(void)sendSwitch:(NSString*)addrPattern index:(int)idx theValue:(int)value{
    F53OSCMessage *message = [F53OSCMessage messageWithAddressPattern:addrPattern arguments:@[[NSNumber numberWithInt:idx],[NSNumber numberWithInt:value]]];
    [self.oscClient sendPacket:message toHost:_host onPort:SENDPORT];
}
-(void)setHost:(NSString *)hostName{
    NSLog(hostName);
    _host = hostName;
}

-(void)takeMessage:(F53OSCMessage *)message {
    
    if ([message.addressPattern isEqualToString:@"/RMS"]) {
        
    }
}

@end
