//
//  SliderViewController.m
//  ToDo List
//
//  Created by nPrimary on 5/31/15.
//  Copyright (c) 2015 nPrimary. All rights reserved.
//

#import "SliderViewController.h"

#define RECEIVEPORT 3002

@interface SliderViewController ()

@property (strong, nonatomic) F53OSCServer* oscServer;
@property (weak, nonatomic) IBOutlet UILabel *addressLabel;
@property (weak, nonatomic) IBOutlet UILabel *argumentsLabel;
@property (weak, nonatomic) IBOutlet UITextField *host;
@property (weak, nonatomic) IBOutlet UISegmentedControl *segmentButtons;
@property (weak, nonatomic) IBOutlet UIStepper *incDec;
@property (weak, nonatomic) IBOutlet UITextField *incDecDisplay;
@property (weak, nonatomic) IBOutlet UISwitch *onOffSwitch;
@property (weak, nonatomic) IBOutlet UITextField *leftRMSLabel;
@property (weak, nonatomic) IBOutlet UITextField *rightRMSLabel;
@end

@implementation SliderViewController

- (IBAction)sliderValue:(id)sender {
    
    UISlider *aSlider = (UISlider*)sender;
    self.label.text = [NSString stringWithFormat:@"%f",aSlider.value];
    [[appDel oscManager] sendSlider:@"/slider" sliderNum:(int)aSlider.tag val2:aSlider.value];
    
}
- (IBAction)hostEditEnd:(id)sender {
    UITextField *theField = (UITextField*)sender;
    [theField resignFirstResponder];
}
- (IBAction)segmentBtnsChanged:(id)sender {
    UISwitch *segButton = (UISwitch*)sender;
    [[appDel oscManager] sendSwitch:@"/switch" index:(int)segButton.tag theValue:segButton.isOn];
    NSLog(@"a %li", (long)[self.segmentButtons selectedSegmentIndex]);
}


- (IBAction)incDecChanged:(id)sender {
    NSLog(@"incDecValue: %f",self.incDec.value);
    self.incDecDisplay.text =[NSString stringWithFormat:@"%f",self.incDec.value ];
}


- (IBAction)onOffSwitchChanged:(id)sender {
    NSLog(@"changed");
}



- (void)viewDidLoad {
    [super viewDidLoad];
    appDel = [[UIApplication sharedApplication] delegate];
//    _oscServer = [[F53OSCServer alloc] init];
//    [_oscServer setPort:RECEIVEPORT];
//    [_oscServer setDelegate:self];
//    [_oscServer startListening];
    
}

//-(void)viewDidAppear:(BOOL)animated{
//    [super viewDidAppear:animated];
//    [_oscServer startListening];
//}
//
//-(void)viewDidDisappear:(BOOL)animated{
//    [super viewDidDisappear:animated];
//    
//    //[_oscServer stopListening];
//}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

-(void)takeMessage:(F53OSCMessage *)message {
    if ([message.addressPattern isEqualToString:@"/RMS"]) {
        //NSLog(@"rms");
        id a = [message.arguments objectAtIndex:0] ;
        id b = [message.arguments objectAtIndex:0] ;
        _leftRMSLabel.text =[NSString stringWithFormat:@"%@",a];
        _rightRMSLabel.text=[NSString stringWithFormat:@"%@",b];
        
    }
}

-(void)setRMS:(int)channel theValue:(float)value {
    if (channel == 0) {
        _leftRMSLabel.text = [NSString stringWithFormat:@"%f",value];
    }
}


/*
 #pragma mark - Navigation
 
 // In a storyboard-based application, you will often want to do a little preparation before navigation
 - (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender {
 // Get the new view controller using [segue destinationViewController].
 // Pass the selected object to the new view controller.
 }
 */

@end
