#ifndef RINGBUFFER_H
#define RINGBUFFER_H

#include <vector>
#include <atomic>

/*
 *
 *

 RingBuffer<float> rb(1024);

 array.resize(32); // not every time

 // Reader thread
 int available = rb.availableRead();
   while (available != array.size()) {
   int read = rb.read(array);
   if (read != array.size()) {
      // Error reading/ Underrun
   }
   available = rb.availableRead();
 }

 float value;
 rb.read(&value);

 rb.registerErrorCallback();
 RbError err = rb.checkError();
 rb.resetError();

 // Writer thread
 rb.write(5.9);
 vector<float> array;
 int written = rb.write(array);
 if (written != array.size()) {
     // Overrun
 }

 rb.flush();
 available = rb.availableRead();
 if (available >= winsize) {
   int read = rb.peek(array, hop);
 }

 *
 *
 */

using namespace std;

template<typename T = float>
class RingBuffer
{
public:
    RingBuffer(int size);
    ~RingBuffer();

    int availableRead();
    int availableWrite();
    int read(T *data, int numElements);
    int read(T &value);
    int write(T *data, int numElements);
    int write(T value);

    int peek(vector<T> writeArray);

    void flush();

private:
    int m_size;
    atomic<int> m_readptr;
    atomic<int> m_writeptr;

    T *m_buffer;

};

#include "ringbuffer.cpp"

#endif // RINGBUFFER_H
